//Source file: Constants.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy;

/**
 * This interface contains constants not associated with any type, but associated with the package org.csapi.jr.se.policy
 *
 */
public interface Constants {

    /**
     * Undefined Error
     */
    public static final int PM_ERROR_UNDEFINED = 0;

    /**
     * Required input variable values not available
     */
    public static final int PM_ERROR_INSUFFICIENT_INPUTS = 1;

    /**
     * Invalid input variable name
     */
    public static final int PM_ERROR_INVALID_INPUT_NAME = 2;

    /**
     * Invalid input variable value
     */
    public static final int PM_ERROR_INVALID_INPUT_VALUE = 3;

    /**
     * Run-time error in evaluation of rule conditions/actions
     */
    public static final int PM_ERROR_EVALUATION_ERROR = 5;

    /**
     * Error reading required rules from DB
     */
    public static final int PM_ERROR_DB_ERROR = 4;

} // org.csapi.jr.se.policy.Constants
