//Source file: PolicyConditionListElement.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy;

/**
 * This data type is a Sequence of Data Elements which describes one element of a condition list. It is a structured data type consisting of a {condition, groupNumber, negated} tuple.
 * 
 */
public final class PolicyConditionListElement implements java.io.Serializable {

    private org.csapi.jr.se.policy.provisioning.PolicyCondition condition;
    private int groupNumber;
    private boolean negated;

    /**
     * Creates a new PolicyConditionListElement instance.
     */
    public PolicyConditionListElement () {}

    /**
     * Creates a new PolicyConditionListElement instance.
     * @param _condition   
     * @param _groupNumber   
     * @param _negated   
     */
    public PolicyConditionListElement (org.csapi.jr.se.policy.provisioning.PolicyCondition _condition, int _groupNumber, boolean _negated) {

        this.condition = _condition;
        this.groupNumber = _groupNumber;
        this.negated = _negated;
    }

    /**
     * This method returns a condition.
     * 
     * @return a org.csapi.jr.se.policy.provisioning.PolicyCondition value
     */
    public org.csapi.jr.se.policy.provisioning.PolicyCondition getCondition() {
        return condition;
    }

    /**
     * This method returns a groupNumber.
     * 
     * @return a int value
     */
    public int getGroupNumber() {
        return groupNumber;
    }

    /**
     * This method returns a negated.
     * 
     * @return a boolean value
     */
    public boolean getNegated() {
        return negated;
    }


    /**
     * This method sets a condition.
     */ 
    public void setCondition(org.csapi.jr.se.policy.provisioning.PolicyCondition condition) {
        this.condition = condition;
    }

    /**
     * This method sets a groupNumber.
     */ 
    public void setGroupNumber(int groupNumber) {
        this.groupNumber = groupNumber;
    }

    /**
     * This method sets a negated.
     */ 
    public void setNegated(boolean negated) {
        this.negated = negated;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PolicyConditionListElement)) {
            return false;
        } 
        PolicyConditionListElement policyConditionListElement = (PolicyConditionListElement) o;
        if ((this.condition != null) && (policyConditionListElement.condition != null)) {
            if(!(this.condition.equals(policyConditionListElement.condition))) {
                return false;
            }
        }
        if(!(this.groupNumber == policyConditionListElement.groupNumber)) {
            return false;
        }
        if(!(this.negated == policyConditionListElement.negated)) {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PolicyConditionListElement

