//Source file: PolicyListType.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy;

/**
 * This defines a homogeneous list type. 
 * 
 */
public final class PolicyListType implements java.io.Serializable {

    private org.csapi.jr.se.policy.PolicyType elementType;

    /**
     * Creates a new PolicyListType instance.
     */
    public PolicyListType () {}

    /**
     * Creates a new PolicyListType instance.
     * @param _elementType   Type of the elements of the list.
     */
    public PolicyListType (org.csapi.jr.se.policy.PolicyType _elementType) {

        this.elementType = _elementType;
    }

    /**
     * This method returns a elementType.
     * 
     * @return a org.csapi.jr.se.policy.PolicyType value
     */
    public org.csapi.jr.se.policy.PolicyType getElementType() {
        return elementType;
    }


    /**
     * This method sets a elementType.
     */ 
    public void setElementType(org.csapi.jr.se.policy.PolicyType elementType) {
        this.elementType = elementType;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PolicyListType)) {
            return false;
        } 
        PolicyListType policyListType = (PolicyListType) o;
        if ((this.elementType != null) && (policyListType.elementType != null)) {
            if(!(this.elementType.equals(policyListType.elementType))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PolicyListType

