//Source file: PolicyType.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy;

/**
 * This is a Tagged Choice of Data Elements with a TpPolicyTypeInfo discriminator.
TpPolicyType allows us to define arbitrarily nested complex types. The level of nested data types actually supported is implementation specific.
 *
 */
public final class PolicyType implements java.io.Serializable {

    private PolicyTypeInfo _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new PolicyType.
     * Tagged choice of data elements always have empty constructors
     */ 
    public PolicyType() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a PolicyTypeInfo value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public PolicyTypeInfo getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a RecordType
     * 
     * @return  a org.csapi.jr.se.policy.PolicyNameType[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.policy.PolicyNameType[] getRecordType() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PolicyTypeInfo.PM_TYPE_RECORD) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.policy.PolicyNameType[]) _object);
    }

    /**
     * This method sets a RecordType
     * 
     * @param value a org.csapi.jr.se.policy.PolicyNameType[] value
     */
    public void setRecordType(org.csapi.jr.se.policy.PolicyNameType[] value) {
        _discriminator = PolicyTypeInfo.PM_TYPE_RECORD;
        _object = value;
    }

    /**
     * This method returns a ListType
     * 
     * @return  a org.csapi.jr.se.policy.PolicyListType value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.policy.PolicyListType getListType() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PolicyTypeInfo.PM_TYPE_LIST) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.policy.PolicyListType) _object);
    }

    /**
     * This method sets a ListType
     * 
     * @param value a org.csapi.jr.se.policy.PolicyListType value
     */
    public void setListType(org.csapi.jr.se.policy.PolicyListType value) {
        _discriminator = PolicyTypeInfo.PM_TYPE_LIST;
        _object = value;
    }

    /**
     * This method returns a SimpleType
     * 
     * @return  a org.csapi.jr.se.SimpleAttributeTypeInfo value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.SimpleAttributeTypeInfo getSimpleType() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PolicyTypeInfo.PM_SIMPLE_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.SimpleAttributeTypeInfo) _object);
    }

    /**
     * This method sets a SimpleType
     * 
     * @param value a org.csapi.jr.se.SimpleAttributeTypeInfo value
     */
    public void setSimpleType(org.csapi.jr.se.SimpleAttributeTypeInfo value) {
        _discriminator = PolicyTypeInfo.PM_SIMPLE_TYPE;
        _object = value;
    }

    /**
     * This method returns a StructuredType
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getStructuredType() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PolicyTypeInfo.PM_STRUCTURED_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a StructuredType
     * 
     * @param value a java.lang.String value
     */
    public void setStructuredType(java.lang.String value) {
        _discriminator = PolicyTypeInfo.PM_STRUCTURED_TYPE;
        _object = value;
    }

    /**
     * This method returns a XMLString
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getXMLString() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PolicyTypeInfo.PM_XML_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a XMLString
     * 
     * @param value a java.lang.String value
     */
    public void setXMLString(java.lang.String value) {
        _discriminator = PolicyTypeInfo.PM_XML_TYPE;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a PolicyTypeInfo value 
     */ 
    public void setUndefined(PolicyTypeInfo discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof PolicyType)) {
            return false;
        } else {
            PolicyType policyType= (PolicyType)o;
            if(!(this._object.equals(policyType._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(policyType._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PolicyType

