//Source file: PolicyTypeInfo.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy;

/**
 * TpPolicyTypeInfo is an enumerated type used as a discriminator for the TpPolicyType structure.
 *
 */
public final class PolicyTypeInfo implements java.io.Serializable {

    private int _value;
    private static int _size = 5;
    private static PolicyTypeInfo[] _array = new PolicyTypeInfo[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private PolicyTypeInfo(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * Simple type
     */
    public static final int _PM_SIMPLE_TYPE =  0;

    /**
     * Simple type
     */
    public static final PolicyTypeInfo PM_SIMPLE_TYPE = new PolicyTypeInfo(_PM_SIMPLE_TYPE);

    /**
     * Record type
     */
    public static final int _PM_TYPE_RECORD =  1;

    /**
     * Record type
     */
    public static final PolicyTypeInfo PM_TYPE_RECORD = new PolicyTypeInfo(_PM_TYPE_RECORD);

    /**
     * List type
     */
    public static final int _PM_TYPE_LIST =  2;

    /**
     * List type
     */
    public static final PolicyTypeInfo PM_TYPE_LIST = new PolicyTypeInfo(_PM_TYPE_LIST);

    /**
     * Structured Type
     */
    public static final int _PM_STRUCTURED_TYPE =  3;

    /**
     * Structured Type
     */
    public static final PolicyTypeInfo PM_STRUCTURED_TYPE = new PolicyTypeInfo(_PM_STRUCTURED_TYPE);

    /**
     * XML Type
     */
    public static final int _PM_XML_TYPE =  4;

    /**
     * XML Type
     */
    public static final PolicyTypeInfo PM_XML_TYPE = new PolicyTypeInfo(_PM_XML_TYPE);


    /**
     * Method allows class to replace/resolve the object read from the stream before it 
     * is returned to the caller. By implementing this method, a class can directly control
     * the types and instances of its own instances being deserialized.
     *
     * @return the resolved PolicyTypeInfo object 
     */
    private Object readResolve() throws java.io.ObjectStreamException {
        return _array[_value];
    }

    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the PolicyTypeInfo object
     */
    public String getValueText() {
        switch (_value) {
            case _PM_SIMPLE_TYPE:
                return "PM_SIMPLE_TYPE";
            case _PM_TYPE_RECORD:
                return "PM_TYPE_RECORD";
            case _PM_TYPE_LIST:
                return "PM_TYPE_LIST";
            case _PM_STRUCTURED_TYPE:
                return "PM_STRUCTURED_TYPE";
            case _PM_XML_TYPE:
                return "PM_XML_TYPE";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 4
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static PolicyTypeInfo getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PolicyTypeInfo)) {
            return false;
        }
        PolicyTypeInfo policyTypeInfo = (PolicyTypeInfo) o; 
        if(!(this.getValue() == policyTypeInfo.getValue())) {
            return false;
        }
        if (this.hashCode() != policyTypeInfo.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PolicyTypeInfo

