//Source file: EvalPolicy.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.evaluation;

/**
 * This interface represents a EvalPolicy activity object.<BR>
 *
 */
public interface EvalPolicy extends org.csapi.jr.se.Activity {

    /**
     * Returns a reference to the PolicyEvalManager responsible for creation of the EvalPolicy.
     *
     * @return  A reference to the PolicyEvalManager responsible for creation of the EvalPolicy.
     */
    org.csapi.jr.se.policy.evaluation.PolicyEvalManager getPolicyEvalManager();

    /**
     * Adds a EvalPolicyListener which is interested in events generated by the EvalPolicy.
     *
     * @param  evalPolicyListener  A reference to the EvalPolicyListener which is to be added as
     *        a listener.
     */
    void addEvalPolicyListener(org.csapi.jr.se.policy.evaluation.EvalPolicyListener evalPolicyListener);

    /**
     * Removes a EvalPolicyListener which is no longer interested events generated by the EvalPolicy.
     *
     * @param  evalPolicyListener  A reference to the EvalPolicyListener which is to be removed as
     *        a listener.
     */
    void removeEvalPolicyListener(org.csapi.jr.se.policy.evaluation.EvalPolicyListener evalPolicyListener);

    /**
     * Invokes the evalPolicyReq() method on the Parlay Gateway.
     */
    void evalPolicyReq(
           java.lang.String                domainName,
           java.lang.String                signatureName,
           org.csapi.jr.se.policy.PolicyNameValue[] inputVariables)
      throws org.csapi.jr.se.PlatformException,
       java.lang.IllegalStateException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;


    /**
     * Invokes the abortEvalPolicyReq() method on the Parlay Gateway.
     */
    void abortEvalPolicyReq(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;


}
