//Source file: EvalPolicyErrEvent.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.evaluation;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the evalPolicyErr() method on the callback interface 
 * has occurred.<BR>
 *
 */
public final class EvalPolicyErrEvent extends java.util.EventObject {

    /**
     * Constructor for the EvalPolicyErrEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public EvalPolicyErrEvent(java.lang.Object source,
        int                             error) {

        super(source);
      this.error = error;
 
    }

    int                             error;

    /**
     *  This method is used to retrieve the parameter value of 'error' passed up
     *  from the Gateway in it's call to the evalPolicyErr() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'error' used on creation of this event.
     */
    public int getError() {

        return this.error;
    }
       
}

