//Source file: EvalPolicyListener.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.evaluation;

/**
 * This interface is to be implemented for receiving events issued by the EvalPolicy activity object.<BR>
 *
 */
public interface EvalPolicyListener extends java.util.EventListener {

    /**
     * Called due to a Gateway initiated call to the evalPolicyRes() method on
     * the callback interface
     *
     * @param  evalPolicyResEvent  Reference to a EvalPolicyResEvent event
     *      emitted from the activity object.
     */
     void onEvalPolicyResEvent(org.csapi.jr.se.policy.evaluation.EvalPolicyResEvent evalPolicyResEvent);


    /**
     * Called due to a Gateway initiated call to the evalPolicyErr() method on
     * the callback interface
     *
     * @param  evalPolicyErrEvent  Reference to a EvalPolicyErrEvent event
     *      emitted from the activity object.
     */
     void onEvalPolicyErrEvent(org.csapi.jr.se.policy.evaluation.EvalPolicyErrEvent evalPolicyErrEvent);


}
