//Source file: EvalPolicyResEvent.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.evaluation;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the evalPolicyRes() method on the callback interface 
 * has occurred.<BR>
 *
 */
public final class EvalPolicyResEvent extends java.util.EventObject {

    /**
     * Constructor for the EvalPolicyResEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public EvalPolicyResEvent(java.lang.Object source,
        org.csapi.jr.se.policy.PolicyNameValue[] outputVariables) {

        super(source);
      this.outputVariables = outputVariables;
 
    }

    org.csapi.jr.se.policy.PolicyNameValue[] outputVariables;

    /**
     *  This method is used to retrieve the parameter value of 'outputVariables' passed up
     *  from the Gateway in it's call to the evalPolicyRes() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'outputVariables' used on creation of this event.
     */
    public org.csapi.jr.se.policy.PolicyNameValue[] getOutputVariables() {

        return this.outputVariables;
    }
       
}

