//Source file: PolicyEvalManager.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.evaluation;

/**
 * This interface represents a PolicyEvalManager.<BR>
 *
 */
public interface PolicyEvalManager extends org.csapi.jr.se.Service {

    /**
     * Invokes the evalPolicy() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyNameValue[] evalPolicy(
           java.lang.String                domainName,
           java.lang.String                signatureName,
           org.csapi.jr.se.policy.PolicyNameValue[] inputVariables)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the generateEvent() method on the Parlay Gateway.
     */
    void generateEvent(
           java.lang.String                domainName,
           java.lang.String                eventDefinitionName,
           org.csapi.jr.se.Attribute[] attributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Creates a EvalPolicy object and returns a reference to the interface used to gain access
     * to it's methods.
     *
     * @return  A reference to the EvalPolicy interface.
     */
    org.csapi.jr.se.policy.evaluation.EvalPolicy createEvalPolicy();

    /**
     * Creates a Notification object and returns a reference to the interface used to gain access
     * to it's methods.
     *
     * @return  A reference to the Notification interface.
     */
    org.csapi.jr.se.policy.evaluation.Notification createNotification();

}
