//Source file: Policy.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.provisioning;

/**
 * This interface represents a Policy.<BR>
 *
 */
public interface Policy extends org.csapi.jr.se.Service {

    /**
     * Invokes the getAttribute() method on the Parlay Gateway.
     */
    org.csapi.jr.se.Attribute getAttribute(
           java.lang.String                attributeName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the setAttribute() method on the Parlay Gateway.
     */
    void setAttribute(
           org.csapi.jr.se.Attribute targetAttribute)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getAttributes() method on the Parlay Gateway.
     */
    org.csapi.jr.se.Attribute[] getAttributes(
           java.lang.String[]              attributeNames)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the setAttributes() method on the Parlay Gateway.
     */
    void setAttributes(
           org.csapi.jr.se.Attribute[] targetAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

}
