//Source file: PolicyDomain.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.provisioning;

/**
 * This interface represents a PolicyDomain.<BR>
 *
 */
public interface PolicyDomain extends org.csapi.jr.se.Service {

    /**
     * Invokes the getParentDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyDomain getParentDomain()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the createDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyDomain createDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyDomain getDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeDomain() method on the Parlay Gateway.
     */
    void removeDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getDomainCount() method on the Parlay Gateway.
     */
    int getDomainCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getDomainIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getDomainIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyGroup createGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyGroup getGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeGroup() method on the Parlay Gateway.
     */
    void removeGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getGroupCount() method on the Parlay Gateway.
     */
    int getGroupCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getGroupIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getGroupIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createRule() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyRule createRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRule() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyRule getRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeRule() method on the Parlay Gateway.
     */
    void removeRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRuleCount() method on the Parlay Gateway.
     */
    int getRuleCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getRuleIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getRuleIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createEventDefinition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyEventDefinition createEventDefinition(
           java.lang.String                eventDefinitionName,
           java.lang.String[]              requiredAttributes,
           java.lang.String[]              optionalAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getEventDefinition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyEventDefinition getEventDefinition(
           java.lang.String                eventDefinitionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeEventDefinition() method on the Parlay Gateway.
     */
    void removeEventDefinition(
           java.lang.String                eventDefinitionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getEventDefinitionCount() method on the Parlay Gateway.
     */
    int getEventDefinitionCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getEventDefinitionIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getEventDefinitionIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createVariableSet() method on the Parlay Gateway.
     */
    void createVariableSet(
           java.lang.String                variableSetName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getVariableSet() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyVar[] getVariableSet(
           java.lang.String                variableSetName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeVariableSet() method on the Parlay Gateway.
     */
    void removeVariableSet(
           java.lang.String                variableSetName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getVariableSetCount() method on the Parlay Gateway.
     */
    int getVariableSetCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getVariableSetIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getVariableSetIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createVariable() method on the Parlay Gateway.
     */
    void createVariable(
           java.lang.String                variableSetName,
           java.lang.String                variableName,
           org.csapi.jr.se.policy.PolicyType variableType)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the setVariableValue() method on the Parlay Gateway.
     */
    void setVariableValue(
           java.lang.String                variableSetName,
           java.lang.String                variableName,
           org.omg.CORBA.Any               variableValue)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getVariableType() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyType getVariableType(
           java.lang.String                variableSetName,
           java.lang.String                variableName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the getVariableValue() method on the Parlay Gateway.
     */
    org.omg.CORBA.Any getVariableValue(
           java.lang.String                variableSetName,
           java.lang.String                variableName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the getVariable() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyVar getVariable(
           java.lang.String                variableSetName,
           java.lang.String                variableName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeVariable() method on the Parlay Gateway.
     */
    void removeVariable(
           java.lang.String                variablSetName,
           java.lang.String                variableName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the createSignature() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicySignature createSignature(
           java.lang.String                signatureName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getSignature() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicySignature getSignature(
           java.lang.String                signatureName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeSignature() method on the Parlay Gateway.
     */
    void removeSignature(
           java.lang.String                signatureName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getSignatureCount() method on the Parlay Gateway.
     */
    int getSignatureCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the getSignatureIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getSignatureIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

}
