//Source file: PolicyEventDefinition.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.provisioning;

/**
 * This interface represents a PolicyEventDefinition.<BR>
 *
 */
public interface PolicyEventDefinition extends org.csapi.jr.se.Service {

    /**
     * Invokes the setRequiredAttributes() method on the Parlay Gateway.
     */
    void setRequiredAttributes(
           org.csapi.jr.se.Attribute[] requiredAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the setOptionalAttributes() method on the Parlay Gateway.
     */
    void setOptionalAttributes(
           org.csapi.jr.se.Attribute[] optionalAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRequiredAttributes() method on the Parlay Gateway.
     */
    org.csapi.jr.se.Attribute[] getRequiredAttributes()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the getOptionalAttributes() method on the Parlay Gateway.
     */
    org.csapi.jr.se.Attribute[] getOptionalAttributes()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the getParentDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyDomain getParentDomain()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

}
