//Source file: PolicyRule.java
//Date: March 2007
//Policy Management Interfaces and Data Types for 3GPP TS 29.198-13 V7.0.0, Release 7

package org.csapi.jr.se.policy.provisioning;

/**
 * This interface represents a PolicyRule.<BR>
 *
 */
public interface PolicyRule extends org.csapi.jr.se.Service {

    /**
     * Invokes the getParentGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyGroup getParentGroup()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the getParentDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyDomain getParentDomain()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the createCondition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyCondition createCondition(
           java.lang.String                conditionName,
           org.csapi.jr.se.policy.PolicyConditionType conditionType,
           org.csapi.jr.se.Attribute[] conditionAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getCondition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyCondition getCondition(
           java.lang.String                conditionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeCondition() method on the Parlay Gateway.
     */
    void removeCondition(
           java.lang.String                conditionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getConditionCount() method on the Parlay Gateway.
     */
    int getConditionCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getConditionIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getConditionIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createAction() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyAction createAction(
           java.lang.String                actionName,
           org.csapi.jr.se.policy.PolicyActionType actionType,
           org.csapi.jr.se.Attribute[] actionAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getAction() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyAction getAction(
           java.lang.String                actionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeAction() method on the Parlay Gateway.
     */
    void removeAction(
           java.lang.String                actionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getActionCount() method on the Parlay Gateway.
     */
    int getActionCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getActionIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyIterator getActionIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the setValidityPeriodConditionByName() method on the Parlay Gateway.
     */
    void setValidityPeriodConditionByName(
           java.lang.String                conditionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the setValidityPeriodCondition() method on the Parlay Gateway.
     */
    void setValidityPeriodCondition(
           org.csapi.jr.se.policy.provisioning.PolicyTimePeriodCondition conditionReference)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getValidityPeriodCondition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.provisioning.PolicyTimePeriodCondition getValidityPeriodCondition()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the unsetValidityPeriodCondition() method on the Parlay Gateway.
     */
    void unsetValidityPeriodCondition()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the setConditionList() method on the Parlay Gateway.
     */
    void setConditionList(
           org.csapi.jr.se.policy.PolicyConditionListElement[] conditionList)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getConditionList() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyConditionListElement[] getConditionList()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the setActionList() method on the Parlay Gateway.
     */
    void setActionList(
           org.csapi.jr.se.policy.PolicyActionListElement[] actionList)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getActionList() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyActionListElement[] getActionList()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

}
